unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    ParamPanel: TPanel;
    Panel1: TPanel;
    Label1: TLabel;
    MEdit: TEdit;
    Panel2: TPanel;
    Label2: TLabel;
    BEdit: TEdit;
    BUnitsCombo: TComboBox;
    ButtonPanel: TPanel;
    GenerateButton: TButton;
    SaveEm: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure GenerateButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  AIOUSB;

procedure DumpStringToFile(S: AnsiString; Path: String);
var
  Fil: TFileStream;

begin
  Fil := TFileStream.Create(Path, fmCreate or fmShareDenyWrite);
  try
    Fil.WriteBuffer(S[1], Length(S));
  finally
    Fil.Free;
  end;
end;

function DumpFileToString(Path: String): AnsiString;
var
  Fil: TFileStream;
  L: Integer;

begin
  Fil := TFileStream.Create(Path, fmOpenRead or fmShareDenyNone);
  try
    L := Fil.Size;
    SetString(Result, nil, L);
    Fil.ReadBuffer(Result[1], L);
  finally
    Fil.Free;
  end;
end;

procedure LoadDefaultFont(IntoFont: TFont);
var
  FontSize: Integer;
  NCM: TNonClientMetrics;

begin
  NCM.cbSize := SizeOf(NCM);
  if SystemParametersInfo(SPI_GETNONCLIENTMETRICS, SizeOf(NCM), @NCM, 0) then begin
    FontSize := Round(-3/4 * NCM.lfMessageFont.lfHeight);
    IntoFont.Name := NCM.lfMessageFont.lfFaceName;
  end
  else begin
    FontSize := Abs(IntoFont.Size);
    IntoFont.Name := 'Tahoma';
  end;
  IntoFont.PixelsPerInch := 72;
  IntoFont.Size := FontSize;
end;



function InU16(X: Extended): Word;
begin
  if X <= $0000 then
    Result := $0000
  else if X >= $FFFF then
    Result := $FFFF
  else
    Result := Round(X)
  ;
end;



procedure TMainForm.FormCreate(Sender: TObject);
begin
  LoadDefaultFont(Font);

  MEdit.Align := alTop;
  BEdit.Align := alTop;
  BUnitsCombo.Align := alTop;
  BUnitsCombo.ItemIndex := 8;
  ParamPanel.Height := BUnitsCombo.BoundsRect.Bottom;
  ClientHeight := ButtonPanel.BoundsRect.Bottom;
end;

procedure TMainForm.GenerateButtonClick(Sender: TObject);
var
  M, B, Y: Extended;
  CalData: array of Word;
  iX: Integer;
  Buf: AnsiString;

begin
  if not SaveEm.Execute then Exit;

  M := StrToFloat(MEdit.Text);
  B := StrToFloat(BEdit.Text);
  case BUnitsCombo.ItemIndex of
    0: B := $10000/10 * B;
    1: B := $10000/20 * B;
    2: B := $10000/5  * B;
    3: B := $10000/10 * B;
    4: B := $10000/2  * B;
    5: B := $10000/4  * B;
    6: B := $10000/1  * B;
    7: B := $10000/2  * B;
    8: ;
    else Exit;
  end;

  SetLength(CalData, $20000);

  for iX := $0000 to $FFFF do begin
    Y := M * (iX - $8000) + B + $8000;
    CalData[iX] := InU16(Y);
    Y := M * iX + B;
    CalData[$10000 + iX] := InU16(Y);
  end;

  SetString(Buf, PAnsiChar(@CalData[0]), Length(CalData) * SizeOf(CalData[0]));
  SetLength(CalData, 0);

  DumpStringToFile(Buf, SaveEm.FileName);
end;

end.
